unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, DrawCircle;

type

  { TForm1 }

  TForm1 = class(TForm)
    DrawCircle1: TDrawCircle;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    v : array of integer;
    h : array of integer;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Timer1Timer(Sender: TObject);
var lv : integer;
begin
 for lv := 0 to pred (DrawCircle1.Circles.Count) do
  begin
   DrawCircle1.Circles.Items[lv].Top  := DrawCircle1.Circles.Items[lv].Top  + v[lv];
   DrawCircle1.Circles.Items[lv].Left := DrawCircle1.Circles.Items[lv].Left + h[lv];
   DrawCircle1.Invalidate;

   if v[lv] > 0 then
    if DrawCircle1.Circles.Items[lv].Top + DrawCircle1.Circles.Items[lv].Diameter  >=
       DrawCircle1.Height then v[lv] := v[lv]*-1;
   if h[lv] > 0 then
    if DrawCircle1.Circles.Items[lv].Left + DrawCircle1.Circles.Items[lv].Diameter  >=
       DrawCircle1.Width  then h[lv] := h[lv]*-1;
   if v[lv] < 0 then
    if DrawCircle1.Circles.Items[lv].Top  <= 0    then v[lv] := v[lv]*-1;
   if h[lv] < 0 then
    if DrawCircle1.Circles.Items[lv].Left <= 0    then h[lv] := h[lv]*-1;

  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var lv : integer;
begin
 setlength(h,DrawCircle1.Circles.Count);
 for lv := 0 to pred (DrawCircle1.Circles.Count) do h[lv] := random(2)+1;
 setlength(v,DrawCircle1.Circles.Count);
 for lv := 0 to pred (DrawCircle1.Circles.Count) do v[lv] := random(2)+1;
end;

end.

